﻿Type=Service
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes
    #StartAtBoot: True
#End Region

Sub Process_Globals
    '--- These global variables will be declared once when the application starts.
    '--- These variables can be accessed from all modules.
    Private tmrStart As Timer
	Dim hc As HttpClient
	Type Renglones (Renglon1 As String, Renglon2 As String)
	Dim Cambios As List
	Dim UltimoRegistro,NuevoRegistro As Int
	Dim PrimeraVez As Boolean
End Sub


Sub Globals
	Dim s As String
End Sub


Sub Service_Create
    '--- set timer to start app after 1 seconds
    '--- this gives time for system to init other stuff
	DisableStrictMode
    tmrStart.Initialize("tmrStart",10000)	
	hc.Initialize("hc")
	PrimeraVez = True
	UltimoRegistro = 0
End Sub

Sub Service_Start (StartingIntent As Intent)
    '--- enabled timer
    tmrStart.Enabled = True
End Sub

Private Sub Service_Destroy
End Sub


Sub tmrStart_Tick
	Buscar_Listado_Cambios
End Sub


Sub DisableStrictMode
   Dim jo As JavaObject
   jo.InitializeStatic("android.os.Build.VERSION")
   If jo.GetField("SDK_INT") > 9 Then
     Dim policy As JavaObject
     policy = policy.InitializeNewInstance("android.os.StrictMode.ThreadPolicy.Builder", Null)
     policy = policy.RunMethodJO("permitAll", Null).RunMethodJO("build", Null)
     Dim sm As JavaObject
     sm.InitializeStatic("android.os.StrictMode").RunMethod("setThreadPolicy", Array(policy))
   End If
End Sub

Sub DameFormatoSpain(FechaIng As String) As String
	Dim S As String
	S = FechaIng.SubString2(8,10) & "/" & FechaIng.SubString2(5,7) & "/" & FechaIng.SubString2(0,4)
	Return (S)
End Sub

Sub DameFormatoSQL(FechaIng As String) As String
	Dim S As String
	S = FechaIng.SubString2(6,10) & "-" & FechaIng.SubString2(3,5) & "-" & FechaIng.SubString2(0,2)
	'S = FechaIng.Replace("/","-")
	Return (S)
End Sub


Sub Buscar_Listado_Cambios
	Dim req As HttpRequest
	Dim Query As String
	Query="SELECT * FROM listadocambios WHERE Activo ='S' ORDER BY Num"
	req.InitializePost2("http://www.linea4vlc.site88.net/linea4vlc.php", Query.GetBytes("UTF8"))
	hc.Execute(req,2) '''''''pasa a respuesta success si todo ok
End Sub


' Esta es la Respuesta de la orden hc.Execute
Sub hc_ResponseSuccess (Response As HttpResponse, tarea As Int)
	Dim res As String
	res = Response.GetString("UTF8")
	Log("Respuesta del servidor: " & res)
	'res =  [{"nombre":"Argentina","id":"AR"},.... hasta ....,{"nombre":"Venezuela","id":"VE"}]
	Dim parser As JSONParser
	parser.Initialize(res)
	'Num	FechaBorrado	IDCreador	FechaCreacion	FechaCambio	Servicio	EsDe	Quiero	Notas	Quien	Activo
	Select tarea
		Case 2
			If PrimeraVez Then
				Dim m As Map
				Cambios.Initialize
				Cambios = parser.NextArray
				For i = 0 To Cambios.Size - 1
				m = Cambios.Get(i)
				UltimoRegistro = m.Get("Num")
				Next
				PrimeraVez = False
			Else
				Dim notificacion As Notification
				'notificacion.Icon = "icon"		
				Dim m As Map
				Cambios.Initialize
				Cambios = parser.NextArray
				For i = 0 To Cambios.Size - 1
					m = Cambios.Get(i)
					Dim Renglon As Renglones
					Dim sprime,ssegun As String
					If m.Get("EsDe") = "M" Then sprime = "MAÑANA"
					If m.Get("EsDe") = "T" Then sprime = "TARDE"
					If m.Get("EsDe") = "D" Then sprime = "DESCANSO"		
					If m.Get("Quiero") = "M" Then ssegun = "MAÑANA"
					If m.Get("Quiero") = "T" Then ssegun = "TARDE"
					If m.Get("Quiero") = "D" Then ssegun = "DESCANSO"
					If m.Get("Servicio") <> "" Then
						Renglon.Renglon1 = "Fecha Cambio: " & DameFormatoSpain(m.Get("FechaCambio")) & " *Servicio " & m.Get("Servicio") & "*"
					Else
						Renglon.Renglon1 = "Fecha Cambio: " & m.Get("FechaCambio")		
					End If			
					Renglon.Renglon2 = sprime & " X " & ssegun		
				'	LblCreacion.Text = m.Get("FechaCreacion")
				'	LblQuien.Text = m.Get("Quien")
				'	EdtNotas.text = m.Get("Notas")
				'	ListView1.AddTwoLines2(Renglon.Renglon1, Renglon.Renglon2, Renglon)
					NuevoRegistro = m.Get("Num")
				Next
			If NuevoRegistro > UltimoRegistro Then
				UltimoRegistro = NuevoRegistro
				ToastMessageShow("Hay cambios",true)
				notificacion.SetInfo("Cambios","Hay nuevos cambios",Main)
			End If
		'ListView1.RequestFocus
			End If
	End Select
End Sub



' Error en la conexión con la Base de datos.
Sub hc1_ResponseError (Response As HttpResponse, Reason As String, StatusCode As Int, tarea As Int)
'	Log("Error: " & Reason & ", StatusCode: " & StatusCode)
'	If Response <> Null Then
'		Log(Response.GetString("UTF8"))
'		Response.Release
'	End If
End Sub

' Error en la conexión con la Base de datos.
Sub hc_ResponseError (Response As HttpResponse, Reason As String, StatusCode As Int, tarea As Int)
'	Log("Error: " & Reason & ", StatusCode: " & StatusCode)
'	If Response <> Null Then
'		Log(Response.GetString("UTF8"))
'		Response.Release
'	End If
End Sub


'Sub ListView1_ItemClick (Position As Int, Value As Object)
'	Dim m As Map
'	m = CambioS.Get(Position)
'	LblQuien.Text = m.Get("Quien")
'	LblCreacion.Text = DameFormatoSpain(m.Get("FechaCreacion"))
'	EdtNotas.Text = m.Get("Notas")
'	LblToma.Text = m.Get("Toma")
'	LblDeje.Text = m.Get("Deje")
'	
'	CNum = m.Get("Num")
'	CDia = DameFormatoSpain(m.Get("FechaCambio"))
'	CServ = m.Get("Servicio")
'	CTengo = m.Get("EsDe")
'	CQuiero = m.Get("Quiero")
'	CNotas = m.Get("Notas")
'	CSoy = m.Get("Quien")
'	CToma = m.Get("Toma")
'	CDeje = m.Get("Deje")
'	CPeculiar = m.Get("Peculiar")
'	IDUnicoTabla = m.Get("IDCreador")
'	xQuien = CSoy
'	xDia = CDia
'	xServicio = CServ
'	If m.Get("Peculiar") = "S" Then
'		ChkPeculiar.Checked = True
'		LblPecu.Text = "[PECULIAR]"
'	Else
'		ChkPeculiar.Checked = False
'		LblPecu.Text = ""
'	End If
'End Sub
'
'Sub BtnTM_Click
'	If IsBackgroundTaskRunning(hc,1) Or IsBackgroundTaskRunning(hc,2) Then ' Está ocupado en llamada anterior.
'		ToastMessageShow("Espera hasta completar la consulta anterior.", False)
'		Return
'	End If
'	ProgressDialogShow("Actualizando listado de Cambios.")
'	Dim req As HttpRequest
'	Dim Query As String
'	Query="SELECT * FROM listadocambios WHERE Activo ='S' and EsDe='T' and Quiero ='M' ORDER BY FechaCambio,FechaCreacion"
'	req.InitializePost2("http://www.linea4vlc.site88.net/linea4vlc.php", Query.GetBytes("UTF8"))
'	hc.Execute(req,2) '''''''pasa a respuesta success si todo ok	
'End Sub
'
